﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2013 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System;

namespace HeuristicLab.Analysis.AlgorithmBehavior.Analyzers {
  public static class DoubleArrayExtensions {
    public static double EuclideanDistance(this double[] p1, double[] p2) {
      double result = 0.0;
      for (int i = 0; i < p1.Length; i++) {
        result += Math.Pow(p1[i] - p2[i], 2);
      }
      return Math.Sqrt(result);
    }

    public static double EuclideanNorm(this double[] p) {
      double norm = 0.0;
      for (int i = 0; i < p.Length; i++) {
        norm += p[i] * p[i];
      }
      return Math.Sqrt(norm);
    }

    public static double DotProduct(this double[] p1, double[] p2) {
      double sum = 0.0;
      for (int i = 0; i < p1.Length; i++) {
        sum += p1[i] * p2[i];
      }
      return sum;
    }
  }
}
